# Nick Holder v1.1 by Peaker
#
# Summery: Use this script to hold your nick when your offline if its a rather
# popular nick that people want to steal :).  It's not fool-proof, but if you
# put it on a fast bot, it'll probably grab your nick before anyone else does.
# Might want to beef up CTCP protection as well.

# Usage: set the variables below.  The bot will come online with the 'held'
# nick (or $org_nick if its in use).  /msg <bot> release <your password> will
# make the bot give up the nick for 20 seconds (be quick!) so you can change
# your nick.  If you don't, after 20 seconds the bot will regain the nickname.
# If you disconnect, or leave, the bot will re-gain your nickname.

# This should be your nick or whatever nick you're trying to hold
set hold_nick "YourNick"

# This is the nick that the bot will have when you're online
set org_nick "YourBot"

# Use away?
# This is a little thing that will leave an away message when holding the nick
# so if people message you they'll know its a bot.  It also sends you a 'note'
# for messages. (1 = yes/0 = no)
set use_away "1"

# User to send notes (the stuff people msg the bot when your nick is being
# held)
set note_nick "YourNick"

# The script.. pheer it
global nick org_nick
set altnick $org_nick
set nick $hold_nick

bind msg n release release_nick
bind dcc n nickhold setnick
if {$use_away} { bind msgm - * away_log }

set keep-nick 1

proc release_nick {nicky host hand a} {
   global botnick nick org_nick
   if {$a == ""} { putserv "NOTICE $nicky :Use /msg $botnick release <pass>" }
   if {![passwdok $hand [lindex $a 0]]} { putlog "\($nicky\!$host\) !$hand\! failed RELEASE" ; return 0 }
   putserv "NOTICE $nicky :$nick released.  Change your nick within 20 seconds or I will change back."
   putserv "NICK $org_nick"
   putlog "\($nicky\!$host\) !$hand! released $nick - Changed to $org_nick\."
   utimer 20 { putserv "NICK $nick" }
}
proc setnick {hand idx a} {
   global botnick nick org_nick
   if {$a == ""} { putdcc $idx "Use: .setnick <nick to hold> <nick to use when unheld>" ; return 0 }
   if {[lindex $a 1] == ""} { putdcc $idx "Use: .setnick <nick to hold> <nick to use when unheld>" ; return 0 }
   set nick [lindex $a 0]
   set org_nick [lindex $a 1]
   global nick org_nick
   putdcc $idx "Held nick set for: $nick - Non-Held nick set for: $org_nick"
   putserv "NICK $nick"
   return 1
}
proc away_log {nick host hand a} {
   global botnick hold_nick note_nick
   set found 0
   switch -exact [lindex $a 0] {
	"addhost" { set found 1 }
	"ident" { set found 1 }
	"info" { set found 1 }
	"who" { set found 1 }
	"help" { set found 1 }
	"voice" { set found 1 }
	"whois" { set found 1 }
	"op" { set found 1 }
	"invite" { set found 1 }
	"go" { set found 1 }
	"die" { set found 1 }
	"jump" { set found 1 }
	"memory" { set found 1 }
	"rehash" { set found 1 }
	"reset" { set found 1 }
	"status" { set found 1 }
   }
   if {$found == 0} {
      if {$botnick == $hold_nick} {
	   puthelp "NOTICE $nick :I am the nick holder for $botnick. Msg from ($nick!$host) logged and stored."
	   catch { sendnote NickHold $note_nick "($nick!$host): $a" } error
      }
   }   
}
putlog "Nick holder by Peaker loaded: Holding $nick ($org_nick as non-held nick.)"